'' +--------------------------------------------------------------------------+
'' | Cluso's Propeller Operating System - OS module: _DIRCPM  --> _DIRCPM.CMD |
'' +--------------------------------------------------------------------------+
'' |  Authors:       (c)2012,2013 "Cluso99" (Ray Rodrick)                     |
'' |  Modifications:                                                          |
'' |  License:       MIT License - See end of file for terms of use           |
'' +--------------------------------------------------------------------------+
'' Each module is called from, and returns to, the prop binary "_CMD.CMD"
'' This OS module uses an included module "__MODULE.SPIN" to perform most of
''  the housekeeping - see this for history, details and acknowledgements.
''
'' This module......
''      Displays a list of files on FAT CPM DISK
''
'' RR20130716   start
'' RR20130717   working
''              add sort 
''
''
''-------------------------------------------------------------------------------------------------
''      CPM2.2 File System
''      ------------------
''      'ZiCog 8MB Hard Disk Parameter Blocks: 17 bytes CP/M + 2 bytes sector size used by SIMH hdsk_dpb
''      dpb_0                           '8MByte Default SIMH Altair HDSK params
''      :spt_low      BYTE      $20     'sectors per track (low byte)                   \ 32x 128byte sectors
''      :spt_high     BYTE      $00     'sectors per track (high byte)                  /
''      :bsh          BYTE      $05     'data allocation Block SHift factor               5=4KB  
''      :blm          BYTE      $1F     'data allocation block mask                       $1F+1=32*128=4KB
''      :exm          BYTE      $01     'EXtent Mask
''      :dsm_low      BYTE      $F9     'maximum data block number (low_byte)           \ $07F9+1= 2048-6 (8MB/4KB=2K -offset)
''      :dsm_high     BYTE      $07     'maximum data block number (high_byte)          /
''      :drm_low      BYTE      $FF     'total number of directory entries (low byte)   \ $03FF+1= 1024 entries of 32 bytes
''      :drm_high     BYTE      $03     'total number of directory entries (high byte)  /          
''      :al0          BYTE      $FF     'determine reserved directory blocks            \ $00FF+1= 256 blocks
''      :al1          BYTE      $00     'determine reserved directory blocks            /
''      :cks_low      BYTE      $00     'size of directory ChecK vector (low byte)      \ $0000 for fixed disk
''      :cks_high     BYTE      $00     'size of directory ChecK vector (high byte)     /
''      :off_low      BYTE      $06     'number of reserved tracks (offset) (low byte)  \ $0006 (6*32*128=6*4KB=24KB)
''      :off_high     BYTE      $00     'number of reserved tracks (offset) (high byte) /
''      :psh          BYTE      $00     'Physical record SHift factor, CP/M 3           \ $0000
''      :phm          BYTE      $00     'PHhysical record Mask, CP/M 3                  /
''      :ss_low       BYTE      $80     'Sector Size (low byte)                         \ $0080= 128 byte sectors
''      :ss_high      BYTE      $00     'Sector Size (high byte)                        /
''                                      'N.B. SS must be 128 for CP/M 2 can be varied for CP/M 3 hard disks.
''      
''      Directory Entries (32 bytes)
''      ----------------------------
''      UU  byte        'user number 0-15 or 0-31, $E5=unused/deleted
''      FN  byte[8]     'filename
''      TY  byte[3]     'filetype b7 of TY[0]=1=readonly, TY[1]=1=hidden
''      EX  byte        'extent counter (low) 0-31 (bits0-4) see S2 for (bits 5-12)
''                      ' where:   dir-entry-no = ((32*S2)|EX)/(exm+1) = ((S2<<5)|EX)>>1
''      S1  byte        'reserved =0
''      S2  byte        'extent counter (high) (bits 5-12)
''      RC  byte        'no of (128 byte) records used in this extent, $80=all
''                      'total records this extent
''                      'where:    recs = ((EX & exm)*128)+RC = ((EX & $01)*128)+RC
''      AL  word[8]     '8 allocation block locations (of 4KB for zicog 8MB HD)
''                      'where the block no is from the dir base (sector 192 for zicog 8MB HD)
''      'There is no allocation map (FAT) and is calculated at CPM boot from the dir entries.                             
{
DRAC_A  .DSK open 897 8388608
DIR at 24576
946 00...01 00 00 80 40 00 41 00 42 00 46 00 47 00 48 00 49 00 4A 00 .BDOS    PRN....@.A.B.F.G.H.I.J.
946 00...03 00 00 80 4B 00 4C 00 4D 00 4E 00 4F 00 50 00 51 00 52 00 .BDOS    PRN....K.L.M.N.O.P.Q.R.
946 00...05 00 00 80 53 00 54 00 55 00 56 00 57 00 58 00 59 00 5A 00 .BDOS    PRN....S.T.U.V.W.X.Y.Z.
947 00...07 00 00 80 5B 00 5C 00 5D 00 5E 00 5F 00 60 00 61 00 62 00 .BDOS    PRN....[.\.].^._.`.a.b.
947 00...09 00 00 80 63 00 64 00 65 00 66 00 67 00 68 00 69 00 80 00 .BDOS    PRN....c.d.e.f.g.h.i...
947 00...0A 00 00 40 81 00 82 00 00 00 00 00 00 00 00 00 00 00 00 00 .BDOS    PRN...@................
1008
}
''-------------------------------------------------------------------------------------------------
'The following are for CPM2.2 & "the" 8MB Hard Disk(s) we have setup in ZiCog
  sectorspertrack = $0020       'spt = 32
  blockshift      = 5           'bsh = 4KB
  blockmask       = $1F         'blm = 4KB (32*128=4096=4KB)
  extentmask      = $01         'exm = 1
  maxblock        = $07F9       'dsm = 2048 -offsettracks -1   (8MB/4KB=2K -off -1)
  direntries      = $03FF+1     'drm +1 
  reservblocks    = $00FF+1     'al0:al1 +1
'                 = $0000       'cks
  offsettracks    = $0006       'off = 6*32*128=6*4KB)
'                 = $00         'psh
'                 = $00         'phm
  sectorsize      = $80         'ss = 128
    
  dirdeleted      = $E5         'directory entry unused/deleted

  dirbase         = offsettracks * sectorspertrack '=192  'base of cpm directory entries (128 byte sectors)
  dirsize         = 32          'directory entry size = 32 bytes
  filebase        = direntries * dirsize/sectorsize + dirbase '=1024*32/128+192=448  'base of file data (end of dir entries)
  sectorsperblock = 1<< blockshift                                                ' 1<<5=32       32          "sectorsperblock"
  blocksize       = sectorsperblock * sectorsize                                  ' 32*128=4096=  4KB
  fatentries      = maxblock + (offsettracks*sectorspertrack/sectorsperblock) + 1 ' 2041+6+1=2048 2048 (x4KB) "No.of 4KB blocks"
  fatdirbase      = dirbase / sectorsperblock                                     ' 192/32=6      6
  fatfilebase     = filebase / sectorsperblock                                    ' 448/32=14     14   (=6+8)
  
  sortsize        = direntries / 2                                                ' 1024/2=512  max files for sorting

'#include "__MODULE.spin"        ' include the common code for OS modules 
#include "__MODULE.spin"

VAR
  byte  databuf[512]

  byte  diskname1[13]                           ' CPM drive stored as a FAT16/32 file (string)
  byte  filename1[13]                           ' CPM filename within diskname1       (string)
  byte  fname1[13]                              ' CPM filename uppercase padded 8+3 w/o dot
' byte  param[10]                               ' optional parameter "-s" (any char)

  byte  sort[12*sortsize]                       ' sort table - stores 8+3 fnames for sorting
  byte  temp[12]                                ' temp swap area
  long  counter, size, line, lines              ' for terminal row/col size
  
DAT
_ModuleStr    byte      "=== DIRCPM ===",0        'module's name (string)


PRI executeCommand(StringPointer) 

  'get the parameters
  str.stringCopy(@diskname1, str.tokenizeString(0))     ' cpm disk file A: stored as a fat file (ZICOG_A2.DSK)
  str.stringCopy(@filename1, str.tokenizeString(0))     ' cpm filename (optional)
' str.stringCopy(@param, str.tokenizeString(0))         ' optional -s parameter

  if strsize(@diskname1) == 0                           ' if no parameters, display usage
    printStringCR(string(" Display the CPM file directory"))
    printStringCR(string("  DIRCPM <cpm_diskname> [<cpm_filename>]"))
    return 0

  if strsize(@filename1) > 0                            ' if exists, prepare fname 8+3 for compare
    ExpandWildcards("?")                                ' expands filename to uppercase(fname) as 8+3 string

  ' determine column width 
  if byte[_hub#_OS_Columns] > 45
    size := byte[_hub#_OS_Columns] / 15                 ' x columns of 15
  else
    size := byte[_hub#_OS_Columns] / 13                 ' x columns of 13            
  lines := (byte[_hub#_OS_Rows] & _hub#_ROW_MASK) - 2 
  counter~
  line~

  buildCpmFileTable                                     ' build the file list table

  return 0


'' +--------------------------------------------------------------------------+
'' | Build CPM FILE Table                                                     |
'' +--------------------------------------------------------------------------+
PRI buildCpmFileTable | errorString, found, i, j, s

'-----------------------------------------------------------------
' Open the CPM Disk (stored as a FAT file)
  errorString := \taf.openFile(@diskname1, "R")                 ' open cpm diskname for R (FAT file representing CPM disk)
  checkError(@diskname1, taf.partitionError, errorString)       ' if error, display & abort

' SEEK TO THE FIRST DIR ENTRY
  errorString := \taf.fileSeek(dirbase * sectorsize)            ' seek to first DIR entry (byte) position
  checkError(@diskname1, taf.partitionError, errorString)       ' if error, display & abort

' NOW MAP ALL/SPECIFIC FILENAME ENTRIES
  s~
  repeat i from 0 to direntries-1
    errorString := taf.readData(@databuf, dirsize)              ' read 32 byte dir entry
    checkError(@filename1, taf.partitionError, errorString)     ' if error, display & abort

    if databuf[0] <> dirdeleted                         ' $E5 = no entry so skip
      '-------------------------------------------------
      ' map ONE/ALL files DIR entries
      if strsize(@fname1) > 0                           ' if exists, then we are only mapping specific filename(s)
        found := true                                   ' preset
        repeat j from 1 to 11                           ' validate filename entry
          if (databuf[j] <> fname1[j-1]) and (fname1[j-1] <> "?")   ' same or wildcard?
            found := false                              ' not found
            quit
      else
        found := true

      '-----------------------------------------------
      if found                                          ' display if ALL/SPECIFIC file(s) found
        ' display this DIR entry ?
        ' we are only interested in the first dir entry for each file
        if (databuf[12] & !extentmask) == 0             ' EX seq#=0 (i.e. the first DIR entry for this filename)
          ' add this file to the sort list
          bytemove(@sort[s*12], @databuf[1], 11)        ' copy fname to slot
          s++                                           ' next slot
          if s => sortsize
            checkError(@diskname1, $F2, string("Sort table too small")) ' if error, display & abort

'-----------------------------------------------------------------
  taf.closeFile
'-----------------------------------------------------------------

'-----------------------------------------------------------------
' NOW SORT & DISPLAY THE FILE ENTRIES
  sortFiles(s)
  displayFiles(s)


PRI ExpandWildcards(char) | i, j
'' Expand the string "filename" -> Uppercase"fname" using the passed wildcard "?" or " "
''  "fname" is expanded to a string of 11 characters for the filename 8+3 format

  i~
  j~
  repeat while filename1[j]                               
    if filename1[j] == "*"                              ' expand "*" with "?"
      if i < 8
        repeat
          fname1[i++] := char                           ' fill with "?" or " "
        until i == 8
      elseif i < 11
        repeat
          fname1[i++] := char                           ' fill with "?" or " "
        until i == 11
      else
        checkError(@filename1, $F0, String("Bad Wildcard Format"))              ' if error, display & abort
    elseif filename1[j] == "."
      repeat while i < 8
        fname1[i++] := char                             ' fill with "?" or " "
      if i > 8
        checkError(@filename1, $F1, String("Filename too long"))                ' if error, display & abort
    else
      if i < 11
        fname1[i++] := filename1[j]
      else
        checkError(@filename1, $F1, String("Filename too long"))                ' if error, display & abort
    j++
  repeat while i < 11
    fname1[i++] := char                                 ' fill with "?" or " "
  fname1[11] := 0                                       ' add in the string terminator                           
  repeat i from 0 to 10
    case fname1[i]
      "a".."z": fname1[i] := fname1[i] - 32             ' convert to ucase(a-z)

PRI sortFiles(s) | i, j, m, n, swapped
'' Sort the Files...

' printStringCR(string("i) Sorting..."))

  repeat                                                ' repeat until non swapped in loop
    swapped~
    repeat i from 0 to s-2                              ' repeat for all entries
      m := i*12                                         ' current entry index
      n := (i*12)+12                                    ' next    entry index
      repeat j from 0 to 10
        if sort[m+j] < sort[n+j]                        ' current < next ?
          quit
        elseif sort[m+j] > sort[n+j]                    ' current > next ?
          bytemove(@temp[0], @sort[m], 11)              '\ swap
          bytemove(@sort[m], @sort[n], 11)              '|
          bytemove(@sort[n], @temp[0], 11)              '/
          swapped~~
          quit
  while swapped

PRI displayFiles(s) | i, j, n
'' Display the Files...

  repeat i from 0 to s-1
    n := i * 12
    repeat j from 0 to 7
      printChar(ascii(sort[n+j]))                       ' filename 8
    printChar(".")
    repeat j from 8 to 10
      printChar(ascii(sort[n+j]))                       ' filename +3
    if size > 3
      PrintString(string("   "))                        ' col width=15
    else
      PrintString(string(" "))                          ' col width=13
    counter++                                           ' add one to counter
    if counter => size                                  ' filled line?
      counter~
      crlf
      line++
    if line => lines                                    ' filled screen?
      PrintString(string("more..."))
      GetKey                                            ' wait for any key
      line~
      crlf
  if counter > 0
    crlf

PRI ASCII(ch)
  result := ch & $7F                                    ' remove top bit
  if result < $20
    result := "."
  if result == $7F
    result := "."


dat                                                   
{{
+------------------------------------------------------------------------------------------------------------------------------+
|                                                   TERMS OF USE: MIT License                                                  |                                                            
+------------------------------------------------------------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    | 
|files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    |
|modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software|
|is furnished to do so, subject to the following conditions:                                                                   |
|                                                                                                                              |
|The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.|
|                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          |
|WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         |
|COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   |
|ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         |
+------------------------------------------------------------------------------------------------------------------------------+
}} 