DAT

'----------------------------------------------------------------------------------------------------------------------                        
' Sample calls:         Routine to copy/fill to/from hub                                                                                    '
'----------------------------------------------------------------------------------------------------------------------                        
' Copy hub to cog 'n' longs (rdlong)
                        mov     counter,               #n                       ' setup n x longs
                        movd    readhub,               #cogaddr                 ' setup cog address
                        mov     hubaddr,               par                      ' setup hub address
                        call    readhub
'----------------------------------------------------------------------------------------------------------------------                        
' Copy hub to cog 'n' bytes (rdbyte)
                        mov     counter,               #n                       ' setup n x bytes
                        movd    readhub,               #cogaddr                 ' setup cog address
                        mov     hubaddr,               par                      ' setup hub address
                        movi    readhub,               #%000000_001             ' setup rdbyte
                        movs    inchub,                #1                       ' setup hub++ (byte)
                        call    readhub                                         ' copy hub-->cog
'----------------------------------------------------------------------------------------------------------------------                        
' Copy cog to hub 'n' longs (wrlong) 
                        mov     counter,               #n                       ' setup n x longs
                        movd    readhub,               #cogaddr                 ' setup cog address
                        mov     hubaddr,               par                      ' setup hub address
                        call    writehub                                        ' copy cog-->hub
'----------------------------------------------------------------------------------------------------------------------                        
' Copy cog to hub 'n' bytes (wrbyte) 
                        mov     counter,               #n                       ' setup n x longs
                        movd    readhub,               #cogaddr                 ' setup cog address
                        mov     hubaddr,               par                      ' setup hub address
                        movi    readhub,               #%000000_000             ' setup wrbyte
                        call    writebyte                                       ' copy cog-->hub
'----------------------------------------------------------------------------------------------------------------------                        
' Fill $$ to hub 'n' longs (wrlong)
                        mov     cogaddr,               --value--                ' setup fill value
                        mov     counter,               #n                       ' setup n x longs
                        movd    readhub,               #cogaddr                 ' setup cog address
                        mov     hubaddr,               par                      ' setup hub address
                        call    writefill                                       ' copy 'value'-->hub
'----------------------------------------------------------------------------------------------------------------------                        
' Routine to copy/fill to/from hub                                                                                    '
'----------------------------------------------------------------------------------------------------------------------                        
writefill               andn    inccog,                maskNR                   ' setup nr for cog++
writehub                andn    readhub,               maskNR                   ' set wrlong/wrword/wrbyte
writebyte
readhub                 rdlong  0-0,                   hubptr                   ' copy hub long
inchub                  add     hubptr,                #4                       ' hub++
inccog                  add     readhub,               h200                     ' cog++
                        djnz    counter,               #readhub                 ' repeat                                  
' reset routine back to rdlong copy
                        movi    readhub,               #%000010_001             ' reset to rdlong
                        mov     inchub,                #addhub4                 ' reset to hub++ (long)                                                                                       
                        movi    inccog,                #%100000_001             ' reset to cog++
writefill_ret
writehub_ret
readhub_ret             ret

maskNR                  long    %000000_0010_0000_000000000_000000000           ' no result & rd/wr instruction bit mask
h200                    long    $200                                            ' 512 (used for D++)
addhub4                 add     hubptr,                #4                       ' hub++

counter                 res     1                                               ' counter
hubaddr                 res     1                                               ' hub address
'----------------------------------------------------------------------------------------------------------------------                        
